$(() => {
$('#vector-map').dxVectorMap({
bounds: [-180, 85, 180, -60],
tooltip: {
enabled: true,
border: {
visible: false,
},
font: { color: '#fff' },
customizeTooltip(arg) {
const name = arg.attribute('name');
const country = countries[name];
if (country) {
return { text: `${name}: ${country.totalArea}M km²`, color: country.color };
}
return null;
},
},
layers: {
dataSource: DevExpress.viz.map.sources.world,
customize(elements) {
$.each(elements, (_, element) => {
const country = countries[element.attribute('name')];
if (country) {
element.applySettings({
color: country.color,
hoveredColor: '#e0e000',
selectedColor: '#008f00',
});
}
});
},
},
onClick(e) {
const { target } = e;
if (target && countries[target.attribute('name')]) {
target.selected(!target.selected());
}
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/dx.all.js"></script>
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/vectormap-data/world.js"></script>
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/vectormap-data/africa.js"></script>
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/vectormap-data/canada.js"></script>
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/vectormap-data/eurasia.js"></script>
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/vectormap-data/europe.js"></script>
<script src="https://cdn3.devexpress.com/jslib/22.2.6/js/vectormap-data/usa.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="vector-map"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}
const countries = {
Russia: { totalArea: 17.12, color: '#1E90FF' },
Canada: { totalArea: 9.98, color: '#B8860B' },
China: { totalArea: 9.59, color: '#BDB76B' },
'United States': { totalArea: 9.52, color: '#FFA07A' },
Brazil: { totalArea: 8.51, color: '#3CB371' },
Australia: { totalArea: 7.69, color: '#D8BFD8' },
India: { totalArea: 3.29, color: '#DB7093' },
Argentina: { totalArea: 2.78, color: '#FFD700' },
Kazakhstan: { totalArea: 2.72, color: '#CD5C5C' },
Algeria: { totalArea: 2.38, color: '#B0C4DE' },
};

import React from 'react';
import VectorMap, {
Layer,
Tooltip,
Border,
Font,
} from 'devextreme-react/vector-map';
import * as mapsData from 'devextreme/dist/js/vectormap-data/world.js';
import { countries } from './data.js';
const bounds = [-180, 85, 180, -60];
export default function App() {
return (
<VectorMap
id="vector-map"
bounds={bounds}
onClick={clickHandler}
>
<Layer
dataSource={mapsData.world}
customize={customizeLayer}>
</Layer>
<Tooltip enabled={true}
customizeTooltip={customizeTooltip}
>
<Border visible={true}></Border>
<Font color="#fff"></Font>
</Tooltip>
</VectorMap>
);
}
function customizeTooltip(arg) {
const name = arg.attribute('name');
const country = countries[name];
if (country) {
return {
text: `${name}: ${country.totalArea}M km²`,
color: country.color,
};
}
return null;
}
function clickHandler({ target }) {
if (target && countries[target.attribute('name')]) {
target.selected(!target.selected());
}
}
function customizeLayer(elements) {
elements.forEach((element) => {
const country = countries[element.attribute('name')];
if (country) {
element.applySettings({
color: country.color,
hoveredColor: '#e0e000',
selectedColor: '#008f00',
});
}
});
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#vector-map {
height: 440px;
}
export const countries = {
Russia: { totalArea: 17.12, color: '#1E90FF' },
Canada: { totalArea: 9.98, color: '#B8860B' },
China: { totalArea: 9.59, color: '#BDB76B' },
'United States': { totalArea: 9.52, color: '#FFA07A' },
Brazil: { totalArea: 8.51, color: '#3CB371' },
Australia: { totalArea: 7.69, color: '#D8BFD8' },
India: { totalArea: 3.29, color: '#DB7093' },
Argentina: { totalArea: 2.78, color: '#FFD700' },
Kazakhstan: { totalArea: 2.72, color: '#CD5C5C' },
Algeria: { totalArea: 2.38, color: '#B0C4DE' },
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/dist/js/vectormap-data/*': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'devextreme/dist/js/vectormap-data': 'js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.2.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.65/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.37/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.7.1/standalone.js',
'prettier/parser-html': 'npm:prettier@2.7.1/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<dx-vector-map
id="vector-map"
[bounds]="[-180, 85, 180, -60]"
(onClick)="click($event)"
>
<dxo-tooltip [enabled]="true" [customizeTooltip]="customizeTooltip">
<dxo-font color="#fff"></dxo-font>
<dxo-border [visible]="false"></dxo-border>
</dxo-tooltip>
<dxi-layer [dataSource]="worldMap" [customize]="customizeLayers"> </dxi-layer>
</dx-vector-map>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxVectorMapModule } from 'devextreme-angular';
import * as mapsData from 'devextreme/dist/js/vectormap-data/world.js';
import { Countries, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
worldMap: any = mapsData.world;
countries: Countries;
constructor(service: Service) {
this.countries = service.getCountries();
this.customizeTooltip = this.customizeTooltip.bind(this);
this.customizeLayers = this.customizeLayers.bind(this);
this.click = this.click.bind(this);
}
customizeTooltip(arg) {
const name = arg.attribute('name');
const country = this.countries[name];
if (country) {
return {
text: `${name}: ${country.totalArea}M km²`,
color: country.color,
};
}
}
customizeLayers(elements) {
elements.forEach((element) => {
const country = this.countries[element.attribute('name')];
if (country) {
element.applySettings({
color: country.color,
hoveredColor: '#e0e000',
selectedColor: '#008f00',
});
}
});
}
click(e) {
const target = e.target;
if (target && this.countries[target.attribute('name')]) {
target.selected(!target.selected());
}
}
}
@NgModule({
imports: [
BrowserModule,
DxVectorMapModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #vector-map {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Country {
totalArea: number;
color: string;
}
export class Countries {
Russia: Country;
Canada: Country;
China: Country;
'United States': Country;
Brazil: Country;
Australia: Country;
India: Country;
Argentina: Country;
Kazakhstan: Country;
Algeria: Country;
}
const countries: Countries = {
Russia: { totalArea: 17.12, color: '#1E90FF' },
Canada: { totalArea: 9.98, color: '#B8860B' },
China: { totalArea: 9.59, color: '#BDB76B' },
'United States': { totalArea: 9.52, color: '#FFA07A' },
Brazil: { totalArea: 8.51, color: '#3CB371' },
Australia: { totalArea: 7.69, color: '#D8BFD8' },
India: { totalArea: 3.29, color: '#DB7093' },
Argentina: { totalArea: 2.78, color: '#FFD700' },
Kazakhstan: { totalArea: 2.72, color: '#CD5C5C' },
Algeria: { totalArea: 2.38, color: '#B0C4DE' },
};
@Injectable()
export class Service {
getCountries(): Countries {
return countries;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/dist/js/vectormap-data/*': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme/dist/js/vectormap-data': 'js/vectormap-data',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.2.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.2.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.20/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.72',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.43',
'devextreme-angular': 'npm:devextreme-angular@22.2.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.2.6/*/package.json',
'npm:devextreme-angular@22.2.6/ui/*/package.json',
'npm:devextreme-angular@22.2.6/package.json',
'npm:devexpress-diagram@2.1.72/package.json',
'npm:devexpress-gantt@4.1.43/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.2.6/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.13.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<dx-vector-map
id="vector-map"
:bounds="bounds"
@click="click"
>
<dx-layer
:data-source="worldData"
:customize="customizeLayer"
/>
<dx-tooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
>
<dx-border :visible="true"/>
<dx-font color="#fff"/>
</dx-tooltip>
</dx-vector-map>
</template>
<script>
import * as mapsData from 'devextreme/dist/js/vectormap-data/world.js';
import {
DxVectorMap,
DxLayer,
DxSource,
DxTooltip,
DxBorder,
DxFont
} from 'devextreme-vue/vector-map';
import { countries } from './data.js';
export default {
components: {
DxVectorMap,
DxLayer,
DxSource,
DxTooltip,
DxBorder,
DxFont
},
data() {
return {
worldData: mapsData.world,
bounds: [-180, 85, 180, -60]
};
},
methods: {
customizeTooltip(info) {
const name = info.attribute('name');
const country = countries[name];
if (country) {
return {
text: `${name}: ${country.totalArea}M km²`,
color: country.color
};
}
},
click({ target }) {
if (target && countries[target.attribute('name')]) {
target.selected(!target.selected());
}
},
customizeLayer(elements) {
elements.forEach((element) => {
const country = countries[element.attribute('name')];
if (country) {
element.applySettings({
color: country.color,
hoveredColor: '#e0e000',
selectedColor: '#008f00'
});
}
});
}
}
};
</script>
<style>
#vector-map {
height: 440px;
}
</style>
import Vue from 'vue';
import App from './App.vue';
new Vue({
el: '#app',
components: { App },
template: '<App/>'
});
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/19.2.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
export const countries = {
'Russia': { totalArea: 17.12, color: '#1E90FF' },
'Canada': { totalArea: 9.98, color: '#B8860B' },
'China': { totalArea: 9.59, color: '#BDB76B' },
'United States': { totalArea: 9.52, color: '#FFA07A' },
'Brazil': { totalArea: 8.51, color: '#3CB371' },
'Australia': { totalArea: 7.69, color: '#D8BFD8' },
'India': { totalArea: 3.29, color: '#DB7093' },
'Argentina': { totalArea: 2.78, color: '#FFD700' },
'Kazakhstan': { totalArea: 2.72, color: '#CD5C5C' },
'Algeria': { totalArea: 2.38, color: '#B0C4DE' }
};
System.config({
transpiler: 'plugin-babel',
paths: {
'npm:': 'https://unpkg.com/'
},
map: {
vue: 'npm:vue@2.6.3/dist/vue.esm.browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@latest/index.js',
'devextreme': 'npm:devextreme@19.2',
'devextreme/dist/js/vectormap-data': 'npm:devextreme@19.2/dist/js/vectormap-data',
'devextreme-vue': 'npm:devextreme-vue@19.2',
jszip: 'npm:jszip@3.1.3/dist/jszip.min.js',
'quill': 'npm:quill@1.3.7/dist/quill.js',
'devexpress-diagram': 'npm:devexpress-diagram',
'devexpress-gantt': 'npm:devexpress-gantt',
'plugin-babel': 'npm:systemjs-plugin-babel@0/plugin-babel.js',
'systemjs-babel-build':
'npm:systemjs-plugin-babel@0/systemjs-babel-browser.js'
},
meta: {
'*.vue': { loader: 'vue-loader' },
'devextreme/dist/js/vectormap-data/*': {
esModule: true
}
},
packages: {
'devextreme-vue': {
main: 'index.js'
},
'devextreme': {
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true
}
});